/**************************************/
/*      Screen ANSI Dislay Attrib     */
/**************************************/
#define NORMAL  "\x1B[0m"
#define BOLD    "\x1B[1m"
#define UNDER   "\x1B[4m"
#define BLINK   "\x1B[5m"
#define REVERSE "\x1B[7m"

#define MAXITEM  2
#define MaxPort  32

/**************************************************************************/
/*                  For Multi-Serial Port Configuration                   */
/**************************************************************************/
int      PortCnt ;
int      CurPort ;
unsigned uart_base[MaxPort] ;
unsigned uart_vect[MaxPort] ;
unsigned uart_enable[MaxPort] ;

#define  SetupItem  5
int      uart_setup[MaxPort][SetupItem];

unsigned CurFunc;

#define  BUFFER_SIZE 2048

/**************************************************************************/
/*               Port Number of Hard Ware Interrupt Register              */
/**************************************************************************/

#define UNMASK    0x21                   /* H/W Intr Unmask register port */

/**************************************************************************/
/*              Definition of UART Base and Control Port                  */
/**************************************************************************/

#define UART_PTR  0x400
#define RCVE_SEND     0                  /* Receive & Send Port Offset    */
#define INTR_ENABLE   1                  /* UART Intr Enable Port Offset  */
#define INTR_ACK      2                  /* Intr Status Check Port Offset */
#define DATA_FMT      3                  /* UART Data Format Setting Port */
#define CTRL_232      4                  /* RS232 Input Control Port      */
#define IO_STATUS     5                  /* I/O Status Port Offset        */
#define MODEM_STATUS  6                  /* RS232 Input Status(Modem)     */

/**************************************************************************/
/*        Definition of Intr Type (COM1,COM3--IRQ4, COM2,COM4--IRQ4)      */
/**************************************************************************/

#define IRQ3      0xb                    /* ( IRQ0=8 ) + 3                */
#define IRQ4      0xc                    /* ( IRQ0=8 ) + 4                */
#define IRQ3_MSK  0xf7                   /* 1111 0111                     */
#define IRQ4_MSK  0xef                   /* 1110 1111                     */

/**************************************************************************/
/*        Definition of Transmitt Protocal Control Character              */
/**************************************************************************/

#define XON       0x11                   /*  DC1                          */
#define XOFF      0x13                   /*  DC3                          */
#define MODEM_LNK 1                      /*  Modem Link                   */
#define DRCT_LNK  2                      /*  Direct Link                  */

unsigned int_type[MaxPort];
unsigned char IntSetStatus[8];
/**************************************************************************/
/*                 Buffer Definition for Incoming Stream                  */
/**************************************************************************/

unsigned char *data_buf[MaxPort] ;     /* I/O Buffer                    */
int      head_ptr[MaxPort],tail_ptr[MaxPort];

/**************************************************************************/
/*                  Definition of MODEM Command String                    */
/**************************************************************************/

#define  HANGUP    "ATH"
#define  DIAL_UP   "ATDT"
#define  SEND_OK    0xd
#define  SUCCESS    1
#define  FAIL       0

