#include <stdio.h>
#include <dos.h>
#include <bios.h>
#include <math.h>
#include <malloc.h>
#include <errno.h>
#include "multi.h"

char    MenuItem[MAXITEM][10]={"Config","Telnet"};
char    CurBuffer[1024];

extern char     field_pos[SetupItem]; /* ={12,27,40,56,65}; */

main(argc,argv)
int      argc;
char    *argv[];
{
        int     i;

        if (ReadPortAddr(argv[1]) == -1)
          exit(1);
        for (i=0;i<8;i++)
          IntSetStatus[i]=(unsigned)0;
        CurFunc=CurPort=0;
        for (i=0;i<PortCnt;i++)
        {
                uart_setup[i][0] =2400;
                uart_setup[i][1] =0;
                uart_setup[i][2] =1;
                uart_setup[i][3] =8;
                uart_setup[i][4] =3;
        }

        show_menu();
        while (1)
        {
                if (select_main()==-1)
                {
                        clrscr(0,0x184f);
                        exit();
                }
                switch(CurFunc)
                {
                case 0:
                  select_port();
                  break;
                case 1:
                  /* outp(uart_vect[CurGroup],0x80); */
                  /* printf("CurGroup :%d\n",CurGroup); */
                  /* printf("CurPort :%d\n",CurPort); */
                  for (i=0;i<PortCnt;i++)
                  {
                        cursor_pos(1+i*8,22);
                        printf("%04x",uart_base[i]);
                  }
                  while (select_port()!=-1)
                  {
                        key_proc();
                        show_menu();
                  }
                  /* outp(uart_vect[CurGroup],0x00); */
                  break;
                }
        }
}

show_menu()
{
        int     i;
        char    DataBuf[80+1];

        clrscr(0,0x184f);
        memset(DataBuf,' ',80);
        DataBuf[80]=0;
        for (i=0;i<MAXITEM;i++)
          memcpy(DataBuf+5+i*10,MenuItem[i],strlen(MenuItem[i]));
        cursor_pos(0,0);
        printf("%s%s%s",REVERSE,DataBuf,NORMAL);

        memset(DataBuf,' ',80);
        DataBuf[80]=0;
        printf("%s",DataBuf);
        for (i=0;i<PortCnt;i++)
        {
                cursor_pos(1+i*8,22);
                printf("%04x",uart_base[i]);
        }

        memset(DataBuf,' ',80);
        DataBuf[80]='\0';
        memcpy(DataBuf+2 ,"Baud Rate:" ,10);
        memcpy(DataBuf+20,"Parity:"    ,7);
        memcpy(DataBuf+32,"StopBit:"   ,8);
        memcpy(DataBuf+45,"DataLength:",11);
        memcpy(DataBuf+61,"IRQ:",4);
        cursor_pos(0,23);
        printf("%s%s%s",UNDER,DataBuf,NORMAL);

        for (i=0;i<PortCnt;i++)
        {
                cursor_pos(i*8,22);
                if (uart_enable[i]==1)
                  printf("*");
                else
                  printf(" ");
        }
        cursor_pos(1+CurPort*8,22);
        printf("%s%04x%s",REVERSE,uart_base[CurPort],NORMAL);
        for (i=0;i<SetupItem;i++)
        {
                cursor_pos(field_pos[i],23);
                if (i==0)
                  printf("%-5d",uart_setup[CurPort][i]);
                else
                  printf("%1d",uart_setup[CurPort][i]);
        }
}
select_main()
{
        int     keyno;
        while (1)
        {
                cursor_pos(CurFunc*10+5,0);
                printf("%s",MenuItem[CurFunc]);
                if ((keyno=_bios_keybrd(_KEYBRD_READ))!=0x1c0d)
                {
                        cursor_pos(CurFunc*10+5,0);
                        printf("%s%s%s",REVERSE,MenuItem[CurFunc],NORMAL);
                }
                switch(keyno)
                {
                case 0x4d00:
                  CurFunc=(CurFunc+1) % MAXITEM;
                  break;
                case 0x4b00:
                  CurFunc=(CurFunc-1) % MAXITEM;
                  break;
                case 0x11b:
                  return(-1);
                case 0x1c0d:
                  return(1);
                  break;
                }
        }
}
select_port()
{
        int     keyno,i;

        while(1)
        {
                for (i=0;i<PortCnt;i++)
                {
                        cursor_pos(i*8,22);
                        if (uart_enable[i]==1)
                          printf("*");
                        else
                          printf(" ");
                }
                cursor_pos(1+CurPort*8,22);
                printf("%s%04x%s",REVERSE,uart_base[CurPort],NORMAL);
                for (i=0;i<SetupItem;i++)
                {
                        cursor_pos(field_pos[i],23);
                        if (i==0)
                          printf("%-5d",uart_setup[CurPort][i]);
                        else
                          printf("%1d",uart_setup[CurPort][i]);
                }
                if ((keyno=_bios_keybrd(_KEYBRD_READ))!=0x1c0d)
                {
                        cursor_pos(1+CurPort*8,22);
                        printf("%04x",uart_base[CurPort]);
                }
                switch(keyno)
                {
                case 0x4d00:
                  CurPort=(CurPort+1) % PortCnt;
                  break;
                case 0x4b00:
                  CurPort=(CurPort-1) % PortCnt;
                  break;
                case 0x11b:
                  return(-1);
                case 0x1c0d:
                  if (CurFunc==0)
                    select_setup();
                  else
                    return(1);
                  break;
                }
        }
}
select_setup()
{
        int     i,keyno,cur_field;
        int     limit[SetupItem][2]={1200,9600,
                                     0   ,2   ,
                                     1   ,2   ,
                                     5   ,8   ,
                                     0   ,7   };
        int     old_setup[SetupItem];
        for (i=0;i<SetupItem;i++)
          old_setup[i]=uart_setup[CurPort][i];
        cur_field=0;
        while (1)
        {
                cursor_pos(field_pos[cur_field],23);
                if (i==0)
                  printf("%s%-5d%s",REVERSE,uart_setup[CurPort][cur_field],NORMAL);
                else
                  printf("%s%1d%s",REVERSE,uart_setup[CurPort][cur_field],NORMAL);
                keyno=_bios_keybrd(_KEYBRD_READ);
                cursor_pos(field_pos[cur_field],23);
                if (i==0)
                  printf("%-5d",uart_setup[CurPort][cur_field]);
                else
                  printf("%1d",uart_setup[CurPort][cur_field]);
                switch(keyno)
                {
                case 0x4800:
                  cur_field=(cur_field-1+SetupItem) % SetupItem;
                  break;
                case 0x5000:
                  cur_field=(cur_field+1) % SetupItem;
                  break;
                case 0x4d00:
                  if (cur_field==0)
                  {
                    uart_setup[CurPort][cur_field]=uart_setup[CurPort][cur_field]*2 ;
                    uart_setup[CurPort][cur_field]=(uart_setup[CurPort][cur_field]>limit[0][1])?1200:uart_setup[CurPort][cur_field];
                  }
                  else
                  {
                    uart_setup[CurPort][cur_field]++;
                    uart_setup[CurPort][cur_field]=(uart_setup[CurPort][cur_field]>limit[cur_field][1])?limit[cur_field][0]:uart_setup[CurPort][cur_field];
                  }
                  break;
                case 0x4b00:
                  if (cur_field==0)
                  {
                    uart_setup[CurPort][cur_field]=uart_setup[CurPort][cur_field]/2 ;
                    uart_setup[CurPort][cur_field]=(uart_setup[CurPort][cur_field]<limit[0][0])?9600:uart_setup[CurPort][cur_field];
                  }
                  else
                  {
                    uart_setup[CurPort][cur_field]--;
                    uart_setup[CurPort][cur_field]=(uart_setup[CurPort][cur_field]<limit[cur_field][0])?limit[cur_field][1]:uart_setup[CurPort][cur_field];
                  }
                  break;
                case 0x11b:
                  for (i=0;i<SetupItem;i++)
                    uart_setup[CurPort][i]=old_setup[i];
                  uart_enable[CurPort]=0;
                  return(-1);
                case 0x1c0d:
                  /*
                  com_initial(COM_PORT,BAUD_RATE,PARITY,STOP_BIT,DATA_LEN,IRQ_NO)
                  */
                  free(data_buf);
                  data_buf[CurPort]=malloc((size_t)BUFFER_SIZE);
                  com_initial(uart_base[CurPort],
                              uart_setup[CurPort][0],
                              uart_setup[CurPort][1],uart_setup[CurPort][2],
                              uart_setup[CurPort][3],uart_setup[CurPort][4]);
                  uart_enable[CurPort]=1;
                  return(1);
                }
        }
}
key_proc()
{
        int     keyno,len;
        unsigned char key_char;
        clrscr(0,0x184f);
        cursor_pos(0,0);
        printf("Terminal Emulator Version 1.0\n");
        while (1)
        {
                if (_bios_keybrd(_KEYBRD_READY)!=0)
                {
                       keyno=_bios_keybrd(_KEYBRD_READ);
                       if (keyno==0x3c00)
                         return(-1);
                       key_char=keyno;
                       com_send(key_char);
                }
                if ((len=rcve(CurBuffer))>0)
                  printf("%s",CurBuffer);
        }
}
