
#define IGNORE	    -2
#define NOECHO	    1

/* NEW LINE TRANSLATION MODES						*/
#define NOXLAT	    0		/* remove nothing--i.e., "raw"		*/
#define LF2CR	    1		/* translate LF to CR			*/
#define CR2LF	    2		/* translate CR to LF			*/
#define EOL2SPACE   3		/* convert CR&LF to spaces		*/
#define REMOVEEOL   4		/* remove all CR and LF 		*/
#define LF2CRLF     5		/* convert LF to CRLF			*/
#define CR2CRLF     6		/* convert CR to CRLF			*/
#define CRLF2LF     7		/* convert CRLF to LF			*/
#define CRLF2CR     8		/* convert CRLF to CR			*/

/* UPPER/LOWER CASE MODES						*/
#define UP_LOW	    0		/* upper and lower--i.e., "row" 	*/
#define UPPER	    1		/* convert to upper			*/
#define LOWER	    2		/* convert to lower			*/

/* XON-XOFF CONTROL							*/
#define NO_XX	    0		/* no XON-XOFF flow control		*/
#define XON_ONLY    1		/* accept only 'xonchar' for XON	*/
#define XON_ANY     2		/* accept anything for XON		*/

/* "FUNCTION" ARGUMENTS FOR USE WITH I/O CONTROL FUNCTIONS		*/
#define SET	    0
#define GET	    1

/* CONTROL ARGUMENTS FOR USE WITH I/O CONTROL FUNCTIONS 		*/
		/** FLAGS **/
#define RAWFLAG     0	    /* flag unformatted I/O			*/
#define T_OUTFLAG   1	    /* used for formatted input only		*/
#define EKOBAKFLAG  2	    /* used for formatted input only		*/
#define WECHOFLAG   3	    /* wait-for-echo flag			*/
#define CONSFLAG    4	    /* console output flag			*/
#define ASCIIFLAG   5	    /* remove high bit flag (&0x7F)		*/
#define CNTRLFLAG   6	    /* remove selected controls flag		*/
#define FILTERFLAG  7	    /* filter unwanted characters flag		*/
#define IB_DLYFLAG  8	    /* interbyte delay flag (output only)	*/
#define IL_DLYFLAG  9	    /* interline delay flag (output only)	*/
		/** DELAYS **/
#define WECHO_DLY   10	    /* echo-wait delay (in tsecs)		*/
#define IB_DLY	    11	    /* interbyte delay (in tsecs)		*/
#define IL_DLY	    12	    /* interline delay (in tsecs)		*/
#define T_OUT	    13	    /* timeout on input only (in tsecs) 	*/
		/** MODES  **/
#define EOLMODE     14	    /* end-of-line mode argument		*/
#define CASEMODE    15	    /* upper/lower mode argument		*/
#define XXMODE	    16	    /* xoff mode argument			*/
		/** DEFINED CHARACTERS **/
#define XOFFC	    17	    /* character defined as XOFF		*/
#define XONC	    18	    /* character defined as XON 		*/
#define IL_DLYC     19	    /* character to trigger interline delay	*/
#define KBORTC	    20	    /* keyboard abort character 		*/
