
#include <stdio.h>
#include "siodef.h"
#include "ascii.h"
#include "sioctl.h"
#include "modem.h"
#include "xmod.h"

#define MENU	CTRL_A		/* key for command summary	    */
#define NOT_READY   -1

void	term(), setup(), setup232();
int	setparity(), setdatalen(), setstops(), setbaud();
SIO	*s_open();

void	upload(), dnload();

extern int s_errno;
extern char *errstr[];
extern char *m_codes[], *m_names[];
extern char *errstr[], *sbstr[], *parstr[], *dlstr[], *brstr[];
extern int x_snd(), x_rcv();

int vers=7;			/* version number		    */

main(argc, argv)
int argc;
char *argv[];
{
    extern struct _siostat  _siolist[];
    int err, portnum = 0;	/* default serial card			*/
    int portaddr;
    SIO *siop;			/* pointer to an SIO			*/
    struct modem *smp;		/* saves typing and runs faster too	*/

    printf("\nEnter the address of serial port and press return: ");
    scanf("%x", &portaddr);
    _siolist[portnum].typep->uart_base = (BYTE *)portaddr;

    //if (argc > 1)
    //	portnum = atoi(argv[1]);
    if ((siop = s_open(portnum)) == NIL)
	{
	printf("\007Cannot open: %s\n", errstr[s_errno]);
	return(s_errno);
	}
    smp = siop->sm;
    //if ((err = m_reset(siop)) != M_SUCCEED)
    //	printf("%s.  (%d)\n", m_codes[err], err);
    //else if ((err = m_whoru(siop)) != M_SUCCEED)
    //	puts("Fatal modem error: no response to ID request.");
    //else if ((err = m_config(siop)) != M_SUCCEED)
    //	puts("Fatal error during modem configuration.");
    //else
    //	{
    //	printf("Found Smartmodem: %s at %s baud. (%d)\n",\
    //	    m_names[smp->modtype], brstr[smp->baudfound], smp->smid);
	term(siop);	    /*	    TERM				*/
    //	}

    if ((s_errno = s_close(siop)) != 0)
	{
	printf("\007Cannot close: %s\n", errstr[s_errno]);
	return(s_errno);
	}
    puts("\nEnd of TERM\n");
    return(0);
}

void term(siop)
SIO *siop;			/* required by the revised functions	*/
{
    int c;			/* must be int to detect -1 return	*/
    printf("TERM, Version %d:  Press Control-%c for a summary of commands \n",\
	vers, MENU + '@');
    for(EVER)			/* eternal loop 			*/
    {
	if ((c = s_inchar(siop)) != NOT_READY)	/* check SIO for byte	*/
	    printf("%c-%X ", c, c);	/* show the char and it's code  */
	    //putchar(c);
	if ((c = inkey()) != NOT_READY) /* if a key is pressed		*/
	    if (c == MENU)		/* and it's the menu key        */
		{
		if (menu(siop) != NUL)	/* if menu returns non-zero	*/
		    break;
		}
	    else
		s_fputc(siop, c);	/* output to SIO		*/
    }
}

#define FORMAT	'A'		/* setup serial parameters	    */
#define RS232	'B'		/* RS-232 output control	    */
#define BRK	'C'		/* send BREAK signal		    */
#define UPLOAD	'D'		/* tramsmit file		    */
#define DNLOAD1 'E'		/* Download with C's buffer         */
#define DNLOAD2 'F'		/* Download with local buffer	    */
#define DIAL	'G'		/* Dial phone number		    */
#define REDIAL	'H'		/* Redial previous number	    */
#define ANSWER	'I'		/* Answer phone call		    */
#define HUP	'J'		/* Hang up phone		    */
#define XSEND	'K'		/* send file with XMODEM protocol   */
#define XRECV	'L'		/* xmit file with XMODEM protocol   */
#define EXIT	'Q'		/* key to exit from term	    */

int menu(siop)
SIO *siop;
{
    void setup();
    void setup232();
    int cbuff(), locbuff();	/* declare capture functions	    */
    int c;
    int retval = 0;
    static char *menus[] =
	{
	"\tA.  Data Format, Baud rate",
	"\tB.  RS-232 control",
	"\tC.  Transmit BREAK signal",
	"\tD.  Upload Text File",
	"\tE.  Download text file (small buffer)",
	"\tF.  Download text file (large buffer)",
	"\tG.  Dial a phone number",
	"\tH.  Redial last phone number",
	"\tI.  Answer incoming call",
	"\tJ.  Hang up phone",
	"\tK.  Send a file using XMODEM protocol",
	"\tL.  Receive a file using XMODEM protocol",
	"\tQ.  EXIT from TERM.",
	""				/* null string terminates list	*/
	};
    char **menup;
    c = !EXIT;
    while (c != EXIT)
	{
	puts("\n\n");
	for (menup = menus; **menup !=NUL ; menup++)
	    printf("%s\n", *menup);
	printf("\n\t\t  Enter selection (CR to quit menu) :  ");
	if ((c = getch()) == CR)
	    break;			/* return to term		*/
	c = toupper(c);
	switch (c)
	    {
	    case EXIT:			/* return to term and exit	*/
		retval = 1;
		break;
	    case FORMAT:		/* Data format, Baud rate	*/
		setup(siop);
		break;
	    case RS232:
		setup232(siop);
		break;
	    case BRK:			/* send BREAK			*/
		setbrk(siop);
		break;
	    case UPLOAD:		/* transmit a disk file 	*/
		upload (siop);
		break;
	    case DNLOAD1:	/* receive a file: use C's file buffer  */
		dnload(siop, cbuff);
		break;
	    case DNLOAD2:	/* receive a file: use local file buffer  */
		dnload(siop, locbuff);
		break;
	    case DIAL:
		if (m_warndcd(siop, OFF) == 0)
		    dial(siop);
		c = EXIT;	/* leave munu after dial		*/
		break;
	    case REDIAL:
		if (m_warndcd(siop, OFF) == 0)
		    printf("\n%s. \n", m_codes[redial(siop)]);
		c = EXIT;	/* leave jenu after redial		*/
		break;
	    case ANSWER:
		if (m_warndcd(siop, OFF) == 0)
		    printf("\n%s. \n", m_codes[m_answer(siop)]);
		c = EXIT;	/* leave menu after answer		*/
		break;
	    case HUP:
		if (m_warndcd(siop, ON) == 0)
		    printf("\nHangup %s. \n", m_hup(siop) == 0 ? "OK" : "error");
		c = EXIT;	/* leave menu after hangup		*/
		break;
	    case XSEND:
		if (m_warndcd(siop, OFF) == 0)
		    x_snd(siop);
		break;
	    case XRECV:
		if (m_warndcd(siop, OFF) == 0)
		    x_rcv(siop);
		break;
	    default:
		puts("Invalid choice\n\007");
		break;
	    }
	}
    puts("\nExiting menu");
    return (retval);			/* will be zero except if EXIT	*/
}

void setup(siop)			/* change data format and baud	*/
SIO *siop;
{
    //extern char *errstr[], *sbstr[], *parstr[], *dlstr[], *brstr[];
    int  (*fcnp)(), choice, errcode, i;
    static char *baudlist[] =
    {
	"\n\n",
	"\t0.  50    bps.	    9.	2000	bps.\n",
	"\t1.  75    bps.	    10. 2400	bps.\n",
	"\t2.  110   bps.	    11. 3600	bps.\n",
	"\t3.  134.5 bps.	    12. 4800	bps.\n",
	"\t4.  150   bps.	    13. 7200	bps.\n",
	"\t5.  300   bps.	    14. 9600	bps.\n",
	"\t6.  600   bps.	    15. 19200	bps.\n",
	"\t7.  1200  bps.	    16. 38400	bps.\n",
	"\t8.  1800  bps. \n",
	""
    };
    static char *paritylist[] =
    {
	"\n\n",
	"\t0. NONE  \n",
	"\t1. ODD   \n",
	"\t2. EVEN  \n",
	"\t3. MARK  \n",
	"\t4. SPACE \n",
	""
    };
    static char *stopbitlist[] =
    {
	"\n\n",
	"\t0.  1     stop bits. \n",
	"\t1.  1 1/2 stop bits. \n",
	"\t2.  2     stop bits. \n",
	""
    };
    static char *dllist[] =
    {
	"\n\n",
	"\t0.  5 data bits. \n",
	"\t1.  6 data bits. \n",
	"\t2.  7 data bits. \n",
	"\t3.  8 data bits. \n",
	""
    };

    for (fcnp = NIL; ; fcnp = NIL)	/* loop forever, reset pointer	*/
	{
	puts("\nCURRENT SETTINGS:\n");
	printf("1. Baud Rate [ %-6.6s ]\n", brstr[baudnow(siop)]);
	printf("2. Parity    [ %-6.6s ]\n", parstr[paritynow(siop)]);
	printf("3. Stop bits [ %-6.6s ]\n", sbstr[stopsnow(siop)]);
	printf("4. Data bits [ %-6.6s ]\n", dlstr[dlnow(siop)]);
	printf("5. Display this menu again.\n");
	printf("Enter your choice (press RETURN to exit): ");
	switch (choice = getch())
	    {
	    case '1':
		fcnp = setbaud;
		for (i = 0; *baudlist[i] != NUL; i++)
		    printf(baudlist[i]);
		/* sexy menu for baud rates here    */
		break;
	    case '2':
		fcnp = setparity;
		for (i = 0; *paritylist[i] != NUL; i++)
		    printf(paritylist[i]);
		/* sexy menu for parity here	    */
		break;
	    case '3':
		fcnp = setstops;
		for (i = 0; *stopbitlist[i] != NUL; i++)
		    printf(stopbitlist[i]);
		/* sexy menu for setp bits here     */
		break;
	    case '4':
		fcnp = setdatalen;
		for (i = 0; *dllist[i] != NUL; i++)
		    printf(dllist[i]);
		/* sexy menu for data length here   */
		break;
	    case '5':
		continue;
	    case CR:
		puts("\nExiting format select.");
		return;
	    default:
		puts("\n007- invalid entry -");
		break;
	    }
	if (fcnp != NIL)	    /* if a valid choice was made	*/
	    do	{
		printf("\nEnter code for new value and press return: ");
		scanf("%d", &choice);
		if ((errcode = (*fcnp)(siop, choice)) != 0)
		    printf("ERROR: %s\n\007", errstr[errcode]);
		} while (errcode != 0);
	}
}

void setup232(siop)
SIO *siop;
{
    extern char *errstr[];	    /* error strings			*/
    extern int	setrts(), setdtr(), setgpo1(), setgpo2();
    static char *statstr[] = {"OFF", "ON", "--"};
    int (*fcnp)();
    int choice, errcode, rtsstat, dtrstat, gpo1stat, gpo2stat, *statp;
    rtsstat = rtsnow(siop); dtrstat = dtrnow(siop);
    gpo1stat = gpo1now(siop); gpo2stat = gpo2now(siop);
    for (fcnp = NIL; ; fcnp = NIL)  /* loop forever, reinitialize pointer*/
	{
	puts  ("\nCURRENT RS-232 INPUT STATUS:");
	puts  ("\tCTS  DSR  DCD  RI   GP1  GP2");
	printf("\t%s  %s  %s  %s  %s  %s\n\n",
	    statstr[iscts(siop)], statstr[isdsr(siop)], statstr[isdcd(siop)],
	    statstr[isri(siop)], statstr[isgpi1(siop)], statstr[isgpi2(siop)]);
	printf("\n1. Toggle RTS  [ %3s ]", statstr[rtsstat]);
	printf("\n2. Toggle DTR  [ %3s ]", statstr[dtrstat]);
	printf("\n3. Toggle GPO1 [ %3s ]", statstr[gpo1stat]);
	printf("\n4. Toggle GPO2 [ %3s ]", statstr[gpo2stat]);
	puts  ("\n5. Exit this function");
	printf("\nEnter your choice and press RETURN: ");
	scanf("%d", &choice);
	switch (choice) 	/* assign function & status pointer	*/
	    {
	    case 1: fcnp = setrts;  statp = &rtsstat;  break;
	    case 2: fcnp = setdtr;  statp = &dtrstat;  break;
	    case 3: fcnp = setgpo1; statp = &gpo1stat; break;
	    case 4: fcnp = setgpo2; statp = &gpo2stat; break;
	    case 5:
		puts ("Exiting RS232 setup.");
		return;
	    default:
		puts ("\007- invalid entry -");
		break;
	    }
	if (fcnp != NIL)	/* if a valid choice was made		*/
	    {
	    if (*statp != BAD_FCN)  /* if this function is supported	*/
		*statp = !(*statp); /* toggle its status		*/
	    if ((errcode = (*fcnp)(siop, *statp)) !=0)
		printf("error: %s\n\007", errstr[errcode]);
	    }
	}
}

/* MODULE NAME: upload
PROGRAM:	TERM4
DESCRIPTION:	Function to transmit (upload) a file.
COMMENTS:	XON/XOFF flow control is supported.
*/

void upload(siop)
SIO *siop;
{
    FILE *rfopen(), *xmitfp;	    /* return type declaractions	*/
    char fnbuff[MAX_NAME_LEN];
    int c;
    int errflag = 0;
    putchar('\n');		    /* now open file, return *FILE	*/
    if ((xmitfp = rfopen("Name of file to upload", fnbuff)) == NIL)
    //if ((xmitfp = fopen("TEST.TXT", "r")) == NIL)
	return; 		    /* user terminated upload		*/
    s_opush(siop);		    /* save output structure_		*/
    s_ocntrl(siop, SET, IB_DLY, _0_SEC_1); /* interbyte delay of .1 secs*/
    s_ocntrl(siop, SET, IL_DLYFLAG, ON);   /* interline delay for slow ttys*/
    s_ocntrl(siop, SET, CONSFLAG, ON);	   /* turn on console output	*/
    while ((c = getc(xmitfp)) != EOF)	   /* transmit the file 	*/
	{
	if (s_keybort(siop))	    /* transfer abort from keyboard?	*/
	    break;
	s_fputc(siop,c);
	}
    putchar('\n');
    errflag = ferror(xmitfp);	    /* see if getc ended with an error	*/
    if (errflag || fclose(xmitfp))  /* if read or close error		*/
	printf("Error %s %s.\n\007", errflag ? "reading" : "closing", fnbuff);
	//printf("Error %s %s.\n\007", errflag ? "reading" : "closing", "TEST.TXT");
    s_opop(siop);		    /* restore output control structure */
    getch(puts("End of upload,\n\n-- Press any key to continue --"));
    puts("Exit upload.");
}

/*
MODULE NAME:	dnload
PROGRAM:	TERM5
DESCRIPTION:	Adminstrative function for downloading captured serial data
		into a disk file.
RETURNS:	void
COMMENTS:	The module calls the actual capture function by passing its
		address.
*/

unsigned long bytetot;		/* total number of bytes captured	*/

void dnload(siop, captfp)
SIO *siop;
int (*captfp)();		/* pointer to a capture function	*/
{
    extern FILE *wfopen();	/* open write FILE, return pointer	*/
    FILE *rcvfp;
    char fnbuff[MAX_NAME_LEN];	/* filename buffer			*/
    int errflag;		/* inbound byte, counter, I/O error	*/
    bytetot = 0;
    if ((rcvfp = wfopen("file name for downloaded file", fnbuff)) == NIL)
	{
	puts("Input file not opened.");
	return;
	}
    s_ipush(siop);		/* save control structure		*/
    s_icntrl(siop, SET, CONSFLAG, ON);	    /* console echo on		*/
    s_icntrl(siop, SET, T_OUTFLAG, OFF);    /* no timeout on input function */
    s_icntrl(siop, SET, T_OUT, _0_SEC_05);  /* but set the interval for later	*/
    printf("\n%s is now ready for capture. Press Esc key to end.\n", fnbuff);
    printf("Terminal output is %s.\n",\
	s_icntrl(siop, GET, CONSFLAG) ? "on" : "off");
    xon(siop);				/* send XON to get started	*/
    errflag = (*captfp)(siop, rcvfp);	/* return code from disk write	*/
    if (!errflag && bytetot)
	{
	fputc(DOS_EOF, rcvfp);		/* tack on end-of-file		*/
	++bytetot;
	errflag = fflush(rcvfp);    /* error on flush == disk prob. full*/
	}
    putchar('\n');
    if (errflag || fclose(rcvfp))   /* don't show stats if error        */
	printf("Error %s %s.\n\007", errflag ? "writing" : "closing", fnbuff);
    else
	printf("%lu bytes written to %s.\n", bytetot, fnbuff);
    puts("\n-- Press any key to continue --\007");
    getch();			    /* ask user to acknowledge error	*/
    s_ipop(siop);		    /* restore contorl structure	*/
    puts("Exiting download");
}

/*
MODULE NAME:	cbuff
PROGRAM:	TERM5
DESCRIPTION:	Subfunction for capturing serial data into a disk file using
		C's internal FILE buffer.
RETURNS:	int: 1 if a disk write error occurs; otherwise 0.
COMMENTS:	XON/XOFF flow control supported. Size if buffer is given by
		the constant BUFSIZ in STDIO.H
*/

#define BYTESLEFT   25		    /* buffer remaining after XPAUSE	*/
#define XPAUSE	    BUFSIZ-BYTESLEFT /* bytes to write before sending XOFF  */

int cbuff(siop, rcvfp)
SIO *siop;
FILE *rcvfp;
{
    extern unsigned long bytetot;
    int buffcnt = 0, error = 0;     /* bytes in C's I/O buffer          */
    int c;
    long i;
    printf("C's %d buffer in use.\n", BUFSIZ);
    s_ipush(siop);
    for (EVER)
	{
	if ((c = inkey()) == siop->s_octl->kbortc)  /* get keyboard byte*/
	    break;			/* end download if abort	*/
	if (c != -1)
	    s_fputc(siop, c);		/* transmit keyboard byte	*/
	if ((c = s_fgetc(siop)) < 0)	/* now check SIO for byte	*/
	    continue;
	putc(c, rcvfp);
	++bytetot;
	if (++buffcnt == XPAUSE)	/* C's I/O buffer almost full?  */
	    {
	    xoff(siop); 		/* XOFF to pause sender 	*/
	    s_icntrl(siop, SET, T_OUTFLAG, ON); /* 1 tsec for late arrivers*/
	    for (i = BYTESLEFT; i > 0; i--)	/* wait for sender to stop */
		{
		if ((c = s_fgetc(siop)) == TIMEOUT)
		    break;		/* timeout, so sender is paused */
		else if (c == IGNORE)
		    continue;
		else
		    {
		    putc(c, rcvfp);	/* catch slow pokes, too	*/
		    ++buffcnt; ++bytetot;
		    }
		}
	    if (c != TIMEOUT)		/* sender didn't respond        */
		puts("\nXOFF Ignored.\007");
	    error = fflush(rcvfp) != 0;
	    s_icntrl(siop, T_OUTFLAG, OFF); /* restore zero wait on input   */
	    if (s_icntrl(siop, GET, CONSFLAG) == OFF)
		printf("%lu total bytes written.\r", bytetot);
	    buffcnt = 0;
	    xon(siop);			/* release sender stuck 	*/
	    if (error)			/* disk error ends capture	*/
		break;
	    }
	}
    puts("\nExit Menu");
    s_ipop(siop);
    return (error);		/* return 0 if no error, 1 if error	*/
}

/*
MODULE NAME:	locbuff
PROGRAM:	TERM5
DESCRIPTION:	Subfunction for capturing serial data into a disk file using
		an externally declared RAM buffer.
RETURNS:	int: 1 if a disk error occurs; -1 if buffer allocation fails;
		otherwise 0.
COMMENTS:	XON/XOFF flow control supported.
*/

//#define BYTESLEFT   25	/* blocks to save for locals		*/
//#define HEADROOM    5
//#define BLKSIZE     128	/* this constant has defined in SIODEF.H    */

int locbuff(siop, rcvfp)
SIO *siop;
FILE *rcvfp;
{
    extern char *bigbuff();
    extern unsigned long bytetot;
    char *buff, *p, *pausep;	/* buffer, buffer pointer, pause marker */
    int c, i;
    int error = 0;
    unsigned numblks;		/* number of BLKSIZE blocks allocated	*/
    unsigned long bufflen = 1;
    p = buff = bigbuff(BLKSIZE, HEADROOM, &numblks);
    if (buff == NIL || numblks == 0)
	{
	puts("Insufficient memory for buffer.");
	return (-1);
	}			/* not tested upon return		*/
    s_ipush(siop);
    bufflen = numblks * BLKSIZE;    /* now convert from blocks to bytes */
    pausep = (char *)(buff + (bufflen - BYTESLEFT));	/* calculate OFF point	*/
    printf("%lu byte local buffer in use.\n", bufflen);
    for (EVER)
	{
	if ((c = inkey()) == siop->s_octl->kbortc)  /* get keyboard byte*/
	    break;		    /* end download			*/
	if (c != -1)
	    s_fputc(siop, c);	    /* transmit keyboard byte		*/
	if ((c = s_fgetc(siop)) < 0)	/* now check SIO for byte	*/
	    continue;
	*p++ = c;
	if (p == pausep)
	    {
	    xoff(siop); 	    /* XOFF to pause sender		*/
	    s_icntrl(siop, SET, T_OUTFLAG, ON); /* 1 sec for late arrivers  */
	    for (i = BYTESLEFT; i > 0; --i)	/* wait for sender to pause */
		{
		if ((c = s_fgetc(siop)) != TIMEOUT) /* catch slow pokes */
		    *p++ = c;
		else
		    break;	    /* timeout = sender acknowledged	*/
		}
	    if (c != TIMEOUT)	    /* sender didn't respond            */
		puts("\nXOFF Ignored.\007");
	    error = fwrite(buff, sizeof(BYTE), p - buff, rcvfp) != p - buff;
	    bytetot += p - buff;    /* reunning byte total		*/
	    if (s_icntrl(siop, GET, CONSFLAG) == OFF && !error)
		printf("%lu total bytes written.\r", bytetot);
	    p = buff;		    /* reset buffer			*/
	    s_icntrl(siop, T_OUTFLAG, OFF); /* restore zero wait on input   */
	    xon(siop);		    /* now release sender		*/
	    if (error == TRUE)
		break;
	    }
	}
    if (!error)
	{
	bytetot += p - buff;	    /* renning byte total		*/
	error = fwrite(buff, sizeof(BYTE), p - buff, rcvfp) != p - buff;
	}
    free(buff);
    s_ipop(siop);
    return (error);
}

/*
MODULE NAME:	dial and redial
PROGRAM:	TERM6
DESCRIPTION:	Dials or redials telephone number on the modem.
*/

int dial(siop)
SIO *siop;
{
    //extern char *m_codes[];
    int result;
    char numbuff[CMDBUFSIZ + 1];
    printf("\nEnter phone number:  ");
    gets(numbuff);
    result = m_dial(siop, numbuff);
    printf("%s. (%d)\n", m_codes[result], result);
    return (result);
}

int redial(siop)
SIO *siop;
{
    printf("\nRedialing previous number:  %s\n", siop->sm->dialbuff);
    return (m_redial(siop));
}
