
/* manifest constants for the virtual register number	*/
#define VBAUDLO     0
#define VBAUDHI     1
#define VINTR	    2
#define VFMT	    3
#define V232OUT     4

/* masks for the 8250				    */
#define RCV_MASK    1	    /* RxRDY mask   */
#define XMIT_MASK   0x20    /* TBE mask     */

#define DLMASK	    0xFC    /* 1111 1100    */
#define DL5_MASK    0	    /* 0000 0000    */
#define DL6_MASK    1	    /* 0000 0001    */
#define DL7_MASK    2	    /* 0000 0010    */
#define DL8_MASK    3	    /* 0000 0011    */

#define STOPMASK    0xFB    /* 1111 1011    */
#define ONE_MASK    0	    /* 0000 0000    */
#define ONE_5_MASK  4	    /* 0000 0100    */
#define TWO_MASK    4	    /* 0000 0100    */

#define PARITYMASK  0xC7    /* 1100 0111    */
#define NONE_MASK   0	    /* 0000 0000    */
#define ODD_MASK    8	    /* 0000 1000    */
#define EVEN_MASK   0x18    /* 0001 1000    */
#define MARK_MASK   0x28    /* 0010 1000    */
#define SPACE_MASK  0x38    /* 0011 1000    */

/* constants to support RS-232 output functions.    */
#define DTRMASK     0xFE    /* 1111 1110    */
#define RTSMASK     0xFD    /* 1111 1101    */
#define GPO1MASK    0xFB    /* 1111 1011    */
#define GPO2MASK    0xF7    /* 1111 0111    */
#define BRK_MASK    0xBF    /* 1011 1111    */

/* RS-232 input constants for U8250.H		    */
#define CTSMASK     0x10    /* 0001 0000    */
#define DSRMASK     0x20    /* 0010 0000    */
#define RIMASK	    0x40    /* 0100 0000    */
#define DCDMASK     0x80    /* 1000 0000    */

/* baud rate divisor constants for U8250.H	    */
#define BH_50	    0x09
#define BL_50	    0x00
#define BH_75	    0x06
#define BL_75	    0x00
#define BH_110	    0x04
#define BL_110	    0x17
#define BH_134	    0x03
#define BL_134	    0x59
#define BH_150	    0x03
#define BL_150	    0x00
#define BH_300	    0x01
#define BL_300	    0x80
#define BH_600	    0x00
#define BL_600	    0xC0
#define BH_1200	    0x00
#define BL_1200	    0x60
#define BH_1800	    0x00
#define BL_1800	    0x40
#define BH_2000	    0x00
#define BL_2000	    0x3A
#define BH_2400	    0x00
#define BL_2400	    0x30
#define BH_3600	    0x00
#define BL_3600	    0x20
#define BH_4800	    0x00
#define BL_4800	    0x18
#define BH_7200	    0x00
#define BL_7200	    0x10
#define BH_9600	    0x00
#define BL_9600	    0x0C
#define BH_19K2     0x00
#define BL_19K2     0x06
#define BH_38K4     0x00
#define BL_38K4     0x03
/* if not supported by hardware
#define BH_19K2     -1
#define BL_19K2     -1
#define BH_38K4     -1
#define BL_38K4     -1
*/
